org.apache.uima.impl

## Class UIMAFramework_impl

- java.lang.Object
- - org.apache.uima.UIMAFramework
  - - org.apache.uima.impl.UIMAFramework_impl

-     public class UIMAFramework_impl
      extends UIMAFramework

  This is the main interface point to the UIMA reference implemention. Applications cannot use this class directly. Use the static methods on `UIMAFramework` instead.

  This class is a singleton which will be accessed by many threads simulatenously. It must be threadsafe.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `debug`

    - ### Fields inherited from class org.apache.uima.UIMAFramework

      `CAS_INITIAL_HEAP_SIZE, JCAS_CACHE_ENABLED, newContextConfigManager, newContextResourceManager, PROCESS_TRACE_ENABLED, SKIP_USER_JCAS_LOADING, SOCKET_KEEPALIVE_ENABLED`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UIMAFramework_impl()` Creates a new UIMAFramework_impl.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `short` | `_getBuildRevision()` To be implemented by subclasses; this should return the build revision number of this implementation.
    `protected Properties` | `_getDefaultPerformanceTuningProperties()` To be implemented by subclasses; this should return a Properties object representing the default performance tuning settings for the framework.
    `protected Logger` | `_getLogger()` To be implemented by subclasses; this should return a reference to the UIMA `Logger` used by this implementation.
    `protected Logger` | `_getLogger(Class component)` To be implemented by subclasses; this should return a reference to the UIMA `Logger` of the specified source class.
    `short` | `_getMajorVersion()` To be implemented by subclasses; this should return the major version number of this implementation.
    `short` | `_getMinorVersion()` To be implemented by subclasses; this should return the minor version number of this implementation.
    `protected CompositeResourceFactory` | `_getResourceFactory()` Retrieves a reference to the `ResourceFactory` used by the UIMA reference implementation.
    `protected ResourceSpecifierFactory` | `_getResourceSpecifierFactory()` To be implemented by subclasses; this should return a reference to the `ResourceSpecifierFactory` used by this implementation.
    `protected XMLParser` | `_getXMLParser()` To be implemented by subclasses; this should return a reference to the UIMA `XMLParser` used by this implementation.
    `protected void` | `_initialize()` To be implemented by subclasses; called from this class's static initializer to complete initialization of the singleton instance.
    `protected CollectionProcessingManager` | `_newCollectionProcessingManager(ResourceManager aResourceManager)` To be implemented by subclasses; this should create a new instance of a class implementing `CollectionProcessingManager`.
    `protected ConfigurationManager` | `_newConfigurationManager()` To be implemented by subclasses; this should return a new instance of the `ConfigurationManager` used by this implementation.
    `protected ResourceManager` | `_newDefaultResourceManager()` To be implemented by subclasses; this should return a new instance of the default `ResourceManager` used by this implementation.
    `protected ResourceManager` | `_newDefaultResourceManagerPearWrapper()` To be implemented by subclasses; this should return a new instance of the default `ResourceManager` used by this implementation.
    `protected Logger` | `_newLogger()` To be implemented by subclasses; this should return a new UIMA `Logger` instance.
    `protected UimaTimer` | `_newTimer()` To be implemented by subclasses; this should return a new UIMA `UimaTimer` instance.
    `protected UimaContextAdmin` | `_newUimaContext()` To be implemented by subclasses; this should return a new instance of the default `UimaContextAdmin` used by this implementation.
    `protected CollectionProcessingEngine` | `_produceCollectionProcessingEngine(CpeDescription aCpeDescription, Map<String,Object> aAdditionalParams)` To be implemented by subclasses; this should produce a `CollectionProcessingEngine` instance from a `cpeDescription`.
    `protected void` | `parseFactoryConfig()` Parses the factoryConfig.xml file and sets up the ResourceFactory, ResourceSpecifierFactory, and XMLParser.

    - ### Methods inherited from class org.apache.uima.UIMAFramework

      `getBuildRevision, getDefaultPerformanceTuningProperties, getInstance, getLogger, getLogger, getMajorVersion, getMinorVersion, getResourceFactory, getResourceSpecifierFactory, getVersionString, getXMLParser, newCollectionProcessingManager, newCollectionProcessingManager, newConfigurationManager, newDefaultResourceManager, newDefaultResourceManagerPearWrapper, newLogger, newTimer, newUimaContext, produceAnalysisEngine, produceAnalysisEngine, produceAnalysisEngine, produceAnalysisEngine, produceCasConsumer, produceCasConsumer, produceCasConsumer, produceCasInitializer, produceCasInitializer, produceCasInitializer, produceCollectionProcessingEngine, produceCollectionProcessingEngine, produceCollectionProcessingEngine, produceCollectionReader, produceCollectionReader, produceCollectionReader, produceResource, produceResource, produceResource, produceTAE, produceTAE, produceTAE, produceTAE`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### debug

          public static final boolean debug

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### UIMAFramework_impl

          public UIMAFramework_impl()

      Creates a new UIMAFramework_impl.

  - ### Method Detail

    - #### _initialize

          protected void _initialize()
                              throws Exception

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; called from this class's static initializer to complete initialization of the singleton instance. This initialization is done outside the constructor so that the `UIMAFramework.getInstance()` method can be used during initialization.
      Specified by:
        `_initialize` in class `UIMAFramework`
      Throws:
        `Exception` - if initialization fails
      See Also:
        `UIMAFramework._initialize()`

    - #### _getMajorVersion

          public short _getMajorVersion()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return the major version number of this implementation.
      Specified by:
        `_getMajorVersion` in class `UIMAFramework`
      Returns:
        the major version number
      See Also:
        `UIMAFramework._getMajorVersion()`

    - #### _getMinorVersion

          public short _getMinorVersion()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return the minor version number of this implementation.
      Specified by:
        `_getMinorVersion` in class `UIMAFramework`
      Returns:
        the minor version number
      See Also:
        `UIMAFramework._getMinorVersion()`

    - #### _getBuildRevision

          public short _getBuildRevision()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return the build revision number of this implementation.
      Specified by:
        `_getBuildRevision` in class `UIMAFramework`
      Returns:
        the build revision number
      See Also:
        `UIMAFramework._getBuildRevision()`

    - #### _getResourceFactory

          protected CompositeResourceFactory _getResourceFactory()

      Retrieves a reference to the `ResourceFactory` used by the UIMA reference implementation.
      Specified by:
        `_getResourceFactory` in class `UIMAFramework`
      Returns:
        the `ResourceFactory` to be used by the application

    - #### _getResourceSpecifierFactory

          protected ResourceSpecifierFactory _getResourceSpecifierFactory()

      To be implemented by subclasses; this should return a reference to the `ResourceSpecifierFactory` used by this implementation.
      Specified by:
        `_getResourceSpecifierFactory` in class `UIMAFramework`
      Returns:
        the `ResourceSpecifierFactory` to be used by the application.

    - #### _getXMLParser

          protected XMLParser _getXMLParser()

      To be implemented by subclasses; this should return a reference to the UIMA `XMLParser` used by this implementation.
      Specified by:
        `_getXMLParser` in class `UIMAFramework`
      Returns:
        the `XMLParser` to be used by the application.

    - #### _newCollectionProcessingManager

          protected CollectionProcessingManager _newCollectionProcessingManager(ResourceManager aResourceManager)

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should create a new instance of a class implementing `CollectionProcessingManager`.
      Specified by:
        `_newCollectionProcessingManager` in class `UIMAFramework`
      Parameters:
        `aResourceManager` - the ResourceManager to be used by the CPM
      Returns:
        a new `CollectionProcessingManager` to be used by the application.
      See Also:
        `UIMAFramework.newCollectionProcessingManager()`

    - #### _getLogger

          protected Logger _getLogger()

      To be implemented by subclasses; this should return a reference to the UIMA `Logger` used by this implementation.
      Specified by:
        `_getLogger` in class `UIMAFramework`
      Returns:
        the `Logger` to be used by the application.

    - #### _getLogger

          protected Logger _getLogger(Class component)

      To be implemented by subclasses; this should return a reference to the UIMA `Logger` of the specified source class.
      Specified by:
        `_getLogger` in class `UIMAFramework`
      Parameters:
        `component` - the class to get the logger for
      Returns:
        the `Logger` of the specified source class

    - #### _newLogger

          protected Logger _newLogger()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return a new UIMA `Logger` instance.
      Specified by:
        `_newLogger` in class `UIMAFramework`
      Returns:
        a new `Logger` instance
      See Also:
        `UIMAFramework._newLogger()`

    - #### _newDefaultResourceManager

          protected ResourceManager _newDefaultResourceManager()

      To be implemented by subclasses; this should return a new instance of the default `ResourceManager` used by this implementation.
      Specified by:
        `_newDefaultResourceManager` in class `UIMAFramework`
      Returns:
        a new `ResourceManager` to be used by the application.

    - #### _newDefaultResourceManagerPearWrapper

          protected ResourceManager _newDefaultResourceManagerPearWrapper()

      To be implemented by subclasses; this should return a new instance of the default `ResourceManager` used by this implementation.
      Specified by:
        `_newDefaultResourceManagerPearWrapper` in class `UIMAFramework`
      Returns:
        a new `ResourceManager` to be used by the application.

    - #### _newConfigurationManager

          protected ConfigurationManager _newConfigurationManager()

      To be implemented by subclasses; this should return a new instance of the `ConfigurationManager` used by this implementation.
      Specified by:
        `_newConfigurationManager` in class `UIMAFramework`
      Returns:
        a new `ConfigurationManager` to be used by the application.

    - #### _newUimaContext

          protected UimaContextAdmin _newUimaContext()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return a new instance of the default `UimaContextAdmin` used by this implementation.
      Specified by:
        `_newUimaContext` in class `UIMAFramework`
      Returns:
        a new `UimaContextAdmin` to be used by the application.
      See Also:
        `UIMAFramework._newUimaContext()`

    - #### _newTimer

          protected UimaTimer _newTimer()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return a new UIMA `UimaTimer` instance.
      Specified by:
        `_newTimer` in class `UIMAFramework`
      Returns:
        a new `Timer` instance
      See Also:
        `UIMAFramework._newTimer()`

    - #### _produceCollectionProcessingEngine

          protected CollectionProcessingEngine _produceCollectionProcessingEngine(CpeDescription aCpeDescription,
                                                                                  Map<String,Object> aAdditionalParams)
                                                                           throws ResourceInitializationException

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should produce a `CollectionProcessingEngine` instance from a `cpeDescription`.
      Specified by:
        `_produceCollectionProcessingEngine` in class `UIMAFramework`
      Parameters:
        `aCpeDescription` - an object that specifies how to create an instance of a `CollectionProcessingEngine`.
        `aAdditionalParams` - a Map containing additional parameters to pass to the `CollectionProcessingEngine.initialize(CpeDescription,Map)` method. May be `null` if there are no parameters. Parameter names are defined as constants on the `AnalysisEngine`, and `Resource`. Furthermore, the entry under the key `Resource.PARAM_PERFORMANCE_TUNING_SETTINGS` is a map which may contain settings with keys defined as constants here `UIMAFramework` interfaces. For example this can be used to set performance-tuning settings as described in `UIMAFramework.getDefaultPerformanceTuningProperties()`.
      Returns:
        a `CollectionProcessingEngine` instance.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the CPE.

    - #### _getDefaultPerformanceTuningProperties

          protected Properties _getDefaultPerformanceTuningProperties()

      Description copied from class: `UIMAFramework`
      To be implemented by subclasses; this should return a Properties object representing the default performance tuning settings for the framework. It must return a new Properties object each time it is called.
      Specified by:
        `_getDefaultPerformanceTuningProperties` in class `UIMAFramework`
      Returns:
        default performance tuning properties

    - #### parseFactoryConfig

          protected void parseFactoryConfig()
                                     throws ParserConfigurationException,
                                            SAXException,
                                            IOException,
                                            ClassNotFoundException,
                                            InstantiationException,
                                            IllegalAccessException

      Parses the factoryConfig.xml file and sets up the ResourceFactory, ResourceSpecifierFactory, and XMLParser.
      Throws:
        `ParserConfigurationException` - if the XML parser could not be configured
        `SAXException` - if factoryConfig.xml could not be parsed
        `ClassNotFoundException` - -
        `IllegalAccessException` - -
        `InstantiationException` - -
        `IOException` - -

Copyright © 2006–2022 The Apache Software Foundation. All rights reserved.